Subject: bug#12507: [debbugs-tracker] Processed: severity 12507 wishlist

From: Karl Fogel <[email-masked]>
Date: Wed, 26 Sep 2012 16:46:28 -0500

I propose the following fix:

  * As Drew suggested, change `bookmark-write-file' to use `write-file'
    instead of `write-region'.

  * Also change the default value of `bookmark-version-control' to be
    `nil' instead of `nospecial', so that backups of the bookmark data
    file are no longer on by default (unless there are already backup
    files present).

But... the only thing that makes me hesitate is the first step, because
back in 2005 we changed `bookmark-write-file' to use `write-region':

  2005-11-12  Karl Fogel  <[email-masked]>
        * bookmark.el (bookmark-write-file): Don't visit the destination
        file, just write the data to it using write-region.  This is
        similar to revision 1.32 of saveplace.el, but with an additional
        change to avoid visiting the file in the first place.

The corresponding change in saveplace.el has just this comment:

  ;; Don't use write-file; we don't want this buffer to visit it.

Why didn't we want to visit the file?  Was there some reason why that
was a bad thing?  Unfortunately, I don't remember, but I don't want to
introduce a regression.

Drew or anyone, any idea what problem we were avoiding?

The status quo does seem a bug.  There are two fixes: make backups work
again, or deprecate `bookmark-version-control' and don't claim that the
bookmark data file can have automatic backups.

(In the meantime, Drew's suggestion in #12503 that `print-circle' be
bound to `t' seems right to me -- I'm trying to get outstanding
bookmark.el bugs fixed in time for the feature freeze on Oct. 1 and that
should be one of the fixes.  If so, then one of the reasons for being
able to back up the bookmarks data file will go away anyway.)

-Karl

"Drew Adams" <[email-masked]> writes:
>It is not just about what you think is fine for users - not when it comes to
>user data.  It's about what individual users think about their data.  Let them
>decide, please.
>
>And as I said, we even have a user option for whether you want your
>bookmark-file backups to be numbered: `bookmark-version-control'.  Imagine that!
>Besides `version-control', which applies to all files, we even give you a
>special option that applies only to your bookmark file.
>
>[...]
>
>What do you think is the point of that option, if your bookmark file is in fact
>NEVER backed up at all?  Do you not see a bug here?
>
>> I wouldn't mind adding a global feature to optionally enable 
>> backups for such files.
>
>Fine.  Let users enable backups, please.  I have no problem with making that a
>user option.
>
>But in that case please document the fact that `bookmark-version-control' has no
>effect when your new option is turned off (no backups).  Let's make it as clear
>as possible how to (a) turn backing up on/off and (b) control the backup naming
>when on.